/*
 *  CividFile.h
 *  DeepRecorder
 *
 *  Created by mmivi on 17.03.09.
 *  Copyright 2009 Deep IT. All rights reserved.
 *
 */

#ifndef _CIVID_FILE_H
#define _CIVID_FILE_H

#define DR_FRAMEFLAG_LMDOWN (0x1 << 0)
#define DR_FRAMEFLAG_RMDOWN (0x1 << 1)
#define DR_FRAMEFLAG_OMDOWN (0x1 << 2)
#define DR_FRAMEFLAG_DOUBLEMDOWN (0x1 << 3)
#define DR_FRAMEFLAG_KEYISREPEATING (0x1 << 4)
#define DR_FRAMEFLAG_HASEXTRADATA (0x1 << 5)
#define DR_FRAMEFLAG_DISPLAYISZOOMED (0x1 << 6)
#define DR_FRAMEFLAG_ZLIB_COMRESSION (0x1 << 7)

typedef enum
	{
		kCividVer1_0 = 0x2C1A7F5E,
		kCividVer1_1 = 0x2C1A7F5F
	} CividVerison;

typedef enum
	{
		kCividFrameKeyStrokes = 'kstr',
		kCividFrameKeyStrokesString = 'ksts',
		kCividFrameCompressionInfo = 'comi',
		kCividFrameEnd = 'endx'
	} CividFrameExtraSignature;

typedef struct 
	{
		CividVerison signature;
		CFAbsoluteTime duration;
		unsigned long frames;
		NSSize initialDimensions;
		long reserverd1;
	} CividVer1_1Info;

typedef struct
	{
		unsigned long blocks;
		unsigned long dataSize;
		NSPoint mousePointerLocation;
		NSSize dimensions;
		unsigned mousePointerIndex;
		CFAbsoluteTime timestamp;
		//long reserved1, reserved2;
		signed short keyCode;
		short frameFlags;
		unsigned int flags;
	} CividVer1_1Frame;

typedef struct
	{
		CividFrameExtraSignature signature;
		unsigned int size;
		unsigned char data[];
	} CividVer1_1Extra;

typedef CividVer1_1Info CividInfo;
typedef CividVer1_1Frame CividFrame;
typedef CividVer1_1Extra CividExtra;

#endif
