//
//  DRICM.h
//  DeepRecorder
//
//  Created by mmivi on 17.03.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>
#import "DREncodingPreset.h"
#import "DRMovieFrame.h"
#import "DREncodedMovieFrame.h"
#import "DRCursor.h"

//#define DR_ICM_NUMFRAMES_KEY @"NumberFrames"

@interface DRICM : NSObject {
	DREncodingPreset * _preset;
	ICMCompressionSessionRef _compressionSession;
	
	BOOL _keepRunning, _stopNow, _pause, _finalize;
	
	id _delegate, _dataSource, _dataDestination;
		
	BOOL _needsToFlipBufferContents;
	
	NSMutableArray * _cursors;
	NSLock * _cursorsLock;
	
	NSBitmapImageRep * mLDownImageRep;
	NSBitmapImageRep * mRDownImageRep;
	NSBitmapImageRep * mODownImageRep;
	NSBitmapImageRep * mLRDownImageRep;
	NSBitmapImageRep * mDoubleDownImageRep;
	
	NSBitmapImageRep * keyBGRep;
	NSMutableString * displayedKeys;
	NSBitmapImageRep * curMouseStateImageRep;
	float curMouseStateOpacity;
	float curKeyStringOpacity;
	BOOL cursorAsRGBA;
	
	double frameRate;
}

- (id) initWithPreset: (DREncodingPreset *)preset andInitialDimensions: (NSSize)initSize;

- (void)start;
- (void)stop;
- (void)pause: (BOOL)flag;

- (void)setDataSource: (id)object;
- (void)setDataDestination: (id)object;
- (void)setDelegate: (id)object;
- (id)delegate;
- (id)dataDestination;
- (id)dataSource;

- (void)setNeedsToFlipBufferContetns: (BOOL)flag;

- (void)setCursors: (NSArray *)cursors;
- (NSArray *)cursors;

- (void)setCursorAsRGBA:(BOOL)flag;
- (BOOL)isCursorAsRGBA;

@end

@interface NSObject (DRICMDelegateInformalProtocol)

- (void)DRICMDidStop: (DRICM *)icm;
- (void)DRICMDidStart: (DRICM *)icm;
- (void)DRICMDidEncodeFrame: (DRICM *)icm;
- (void)DRICM: (DRICM *)icm willEncodeFrame: (DRMovieFrame *)frame;

@end

